#include "mex.h"
#include "CPP/MLData.hpp"
#include "CPP/AOSOLogitBoost.hpp"
#include "utilCPP.h"

using namespace cv;

// Y = AOTOBoost_predict(h, X, T);
void mexFunction(int nlhs,mxArray *plhs[], int nrhs,const mxArray *prhs[]) 
{
  /* Input */
  // get pointer
  double *ptmp = (double*)mxGetData(prhs[0]);
  long long p = (long long) ptmp[0];
  AOSOLogitBoost* pbooster = (AOSOLogitBoost*) p;
  // data X
  MLData te;
  set_X(prhs[1], te.X);
  // T
  int T = (int)mxGetScalar(prhs[2]);

  /* Output */
  int nsample = te.X.rows;
  int K = pbooster->get_class_count();
  plhs[0] = mxCreateNumericMatrix(K, nsample, mxSINGLE_CLASS,mxREAL);
  set_Ymc(plhs[0], te.Y);

  /* Predict */
  pbooster->predict(&te, T);
}