#include "mex.h"
#include "CPP/MLData.hpp"
#include "CPP/AOSOLogitBoost.hpp"
#include "utilCPP.h"

using namespace cv;

// h = AOTOBoost_train(X,Y, var_cat_mask, T,J,v, node_size);
void mexFunction(int nlhs,mxArray *plhs[], int nrhs,const mxArray *prhs[]) 
{
  /* Input */
  MLData tr;
  // training tr X
  set_X(prhs[0], tr.X);
  // response Y
  set_Y(prhs[1], tr.Y);
  // var_cat_mask
  set_mask(prhs[2], tr.var_type);
  // T
  int T = (int)mxGetScalar(prhs[3]);
  // J
  int J = (int)mxGetScalar(prhs[4]);
  // v
  double v = (double)mxGetScalar(prhs[5]);
  // node_size
  int node_size = (int)mxGetScalar(prhs[6]);


  /* train */
  tr.problem_type = PROBLEM_CLS;
  tr.preprocess();

  AOSOLogitBoost* pbooster = new AOSOLogitBoost;
  pbooster->param_.T = T;
  pbooster->param_.v = v;
  pbooster->param_.J = J;
  pbooster->param_.ns = node_size;
  pbooster->train(&tr);


  /*Output*/
  plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
  double* pp = mxGetPr(plhs[0]);
  *pp = (long long) pbooster;
}
