#include "utilCPP.h"


void set_X (const mxArray *from, cv::Mat& to)
{
    int nvar = mxGetM(from);
    int nsample = mxGetN(from);
    float* pdata = (float*)mxGetData(from);

    cv::Mat tmp(nsample,nvar,CV_32FC1,(uchar*)pdata);
    to = tmp;
}

void set_Y (const mxArray *from, cv::Mat& to)
{
  int nsample =  mxGetM(from) * mxGetN(from);
  uchar* pdata = (uchar*)mxGetData(from);

  cv::Mat tmp(nsample,1,CV_32FC1,(uchar*)pdata);
  to = tmp;
}

void set_Ymc( const mxArray *from, cv::Mat& to )
{
  int nsample = mxGetN(from);
  int K = mxGetM(from);
  uchar* pdata = (uchar*)mxGetData(from);

  cv::Mat tmp(nsample,K,CV_32FC1,(uchar*)pdata);
  to = tmp;
}

void set_mask( const mxArray *from, std::vector<VAR_TYPE>& to )
{
  int n = mxGetM(from) * mxGetN(from);
  to.resize(n);
  
  uchar* p = (uchar*)mxGetData(from);
  // TODO: assert mxArray is UINT8
  for (int i = 0; i < n; ++i) {
    uchar elem = *(p+i);
    to[i] = (elem!=0)? VAR_CAT : VAR_NUM;
  }
}

